{"openapi":"3.0.0","info":{"title":"OVHcloud API specification","description":"Specification for OVHcloud API","version":"1.0","contact":{"name":"OVH","email":"api@ml.ovh.net"}},"servers":[{"url":"https://api.eu.ovhcloud.com/v2"}],"components":{"schemas":{"any":{"description":"Can be anything (text, int, bool, json, html, etc.)","example":"This is a content of any type !"},"common.CurrentTask":{"type":"object","description":"Asynchronous operation currently running","properties":{"errors":{"type":"array","description":"Errors that occurred on the task","nullable":true,"items":{"$ref":"#/components/schemas/common.TaskError"},"readOnly":true},"id":{"type":"string","description":"Identifier of the current task","format":"uuid","readOnly":true},"link":{"type":"string","description":"Link to the task details","readOnly":true},"status":{"allOf":[{"$ref":"#/components/schemas/common.CurrentTaskStatusEnum"}],"description":"Current global status of the current task","nullable":true,"readOnly":true},"type":{"type":"string","description":"Type of the current task","readOnly":true}}},"common.CurrentTaskStatusEnum":{"type":"string","description":"Current status of a task. A task in ERROR cannot be retried without your inputs. PENDING tasks will be executed as soon as possible. A RUNNING task is currently executing your original request. SCHEDULED is used for tasks that will be executed in the future.","enum":["ERROR","PENDING","RUNNING","SCHEDULED","WAITING_USER_INPUT"]},"common.ResourceStatusEnum":{"type":"string","description":"Current status of a resource","enum":["CREATING","CREATION_PLANNED","DELETING","ERROR","OUT_OF_SYNC","READY","SUSPENDED","UNKNOWN","UPDATING"]},"common.TaskError":{"type":"object","description":"Errors that occurred on the task","properties":{"message":{"type":"string","description":"Error description","readOnly":true}}},"duration":{"type":"string","description":"Duration (e.g., P1Y2M3DT4H6M9S)","example":"P1Y2M3DT4H6M9S"},"email":{"type":"string","description":"Email address (e.g., api@ml.ovh.net)","format":"email","example":"api@ml.ovh.net"},"iam.ResourceMetadata":{"type":"object","description":"IAM resource metadata embedded in services models","properties":{"displayName":{"type":"string","description":"Resource display name","nullable":true,"readOnly":true},"id":{"type":"string","description":"Unique identifier of the resource","format":"uuid","readOnly":true},"state":{"allOf":[{"$ref":"#/components/schemas/iam.ResourceMetadata.StateEnum"}],"description":"Resource state","nullable":true,"readOnly":true},"tags":{"type":"object","description":"Resource tags. Tags that were internally computed are prefixed with ovh:","nullable":true,"additionalProperties":{"type":"string"},"readOnly":true},"urn":{"type":"string","description":"Unique resource name used in policies","readOnly":true}}},"iam.ResourceMetadata.StateEnum":{"type":"string","description":"Resource state","enum":["EXPIRED","IN_CREATION","OK","SUSPENDED"]},"iam.resource.TagFilter":{"type":"object","description":"Resource tag filter","properties":{"operator":{"allOf":[{"$ref":"#/components/schemas/iam.resource.TagFilter.OperatorEnum"}],"description":"Operator to use in order to filter on the value. Defaults to `EQ`.","nullable":true,"readOnly":true},"value":{"type":"string","description":"Value to use in order to filter tags","readOnly":true}}},"iam.resource.TagFilter.OperatorEnum":{"type":"string","description":"Operator that can be used in order to filter resources tags","enum":["EQ","EXISTS","ILIKE","LIKE","NEQ","NEXISTS"]},"internationalPhoneNumber":{"type":"string","description":"International phone number","format":"phone-number"},"ip":{"type":"string","description":"IP address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipBlock":{"type":"string","description":"IP (v4 or v6) CIDR notation (e.g., 192.0.2.0/24)","format":"ip-block","example":"192.0.2.0/24"},"ipInterface":{"type":"string","description":"IP address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipv4":{"type":"string","description":"IPv4 address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipv4Block":{"type":"string","description":"IPv4 CIDR notation (e.g., 192.0.2.0/24)","format":"ipv4-block","example":"192.0.2.0/24"},"ipv6":{"type":"string","description":"IPv6 address (e.g., 2001:41d0:1:1994::1)","format":"ipv6","example":"2001:41d0:1:1994::1"},"ipv6Block":{"type":"string","description":"IPv6 CIDR notation (e.g., 2001:41d0::/128)","format":"ipv6-block","example":"2001:41d0::/128"},"macAddress":{"type":"string","description":"MAC address (e.g., 00:00:5e:00:53:01)","format":"mac-address","example":"00:00:5e:00:53:01"},"phoneNumber":{"type":"string","description":"Phone number","format":"phone-number"},"time":{"type":"string","description":"Time (e.g., 15:04:05)","format":"time","example":"15:04:05"},"zimbra.OfferEnum":{"type":"string","description":"Commercial name of the offer","enum":["PRO","STARTER"]},"zimbra.OfferStatistics":{"type":"object","description":"Statistics per offer","properties":{"availableAccountsCount":{"type":"integer","description":"Total number of accounts on this offer that can be configured","readOnly":true},"configuredAccountsCount":{"type":"integer","description":"Number of accounts on the offer that are configured","readOnly":true},"offer":{"allOf":[{"$ref":"#/components/schemas/zimbra.OfferEnum"}],"description":"Commercial name of the offer","readOnly":true}}},"zimbra.PlatformCurrentState":{"type":"object","description":"Object representing platform","properties":{"accountsStatistics":{"type":"array","description":"Statistics of accounts on the platform","items":{"$ref":"#/components/schemas/zimbra.OfferStatistics"},"readOnly":true},"clusterHostname":{"type":"string","description":"A zimbra cluster hostname where all customer mailbox are placed","nullable":true,"readOnly":true},"description":{"type":"string","description":"Description of the platform","readOnly":true},"name":{"type":"string","description":"Name of the platform","readOnly":true},"numberOfOrganizations":{"type":"integer","description":"Total number of created organizations in the platform","readOnly":true},"quota":{"type":"number","description":"Maximum storage capacity per account allowed on the platform","readOnly":true}}},"zimbra.PlatformPutPayload":{"type":"object","description":"Object representing Put platform route payload","properties":{"checksum":{"type":"string","description":"Known checksum of the resource, allowing to prevent unwanted side effects"},"targetSpec":{"allOf":[{"$ref":"#/components/schemas/zimbra.PlatformPutTargetSpec"}],"description":"Target platform specification"}},"required":["targetSpec"]},"zimbra.PlatformPutTargetSpec":{"type":"object","description":"Object representing platform","properties":{"description":{"type":"string","description":"Description of the platform"},"name":{"type":"string","description":"Name of the platform"}}},"zimbra.PlatformResponse":{"type":"object","description":"Response for get platform","properties":{"checksum":{"type":"string","description":"Checksum hash in MD5 representation","readOnly":true},"currentState":{"allOf":[{"$ref":"#/components/schemas/zimbra.PlatformCurrentState"}],"description":"Object representing platform","readOnly":true},"currentTasks":{"type":"array","description":"An array containing tasks responses pending on resource extends AsyncResourceBase object","items":{"$ref":"#/components/schemas/common.CurrentTask"},"readOnly":true},"id":{"type":"string","description":"Resource identifier in UUID representation","format":"uuid","readOnly":true},"resourceStatus":{"allOf":[{"$ref":"#/components/schemas/common.ResourceStatusEnum"}],"description":"Current resource status","readOnly":true},"targetSpec":{"allOf":[{"$ref":"#/components/schemas/zimbra.PlatformPutTargetSpec"}],"description":"Object representing platform","readOnly":true}}},"zimbra.PlatformResponseWithIAM":{"type":"object","description":"Response for get platform","properties":{"checksum":{"type":"string","description":"Checksum hash in MD5 representation","readOnly":true},"currentState":{"allOf":[{"$ref":"#/components/schemas/zimbra.PlatformCurrentState"}],"description":"Object representing platform","readOnly":true},"currentTasks":{"type":"array","description":"An array containing tasks responses pending on resource extends AsyncResourceBase object","items":{"$ref":"#/components/schemas/common.CurrentTask"},"readOnly":true},"iam":{"allOf":[{"$ref":"#/components/schemas/iam.ResourceMetadata"}],"description":"IAM resource metadata","nullable":true,"readOnly":true},"id":{"type":"string","description":"Resource identifier in UUID representation","format":"uuid","readOnly":true},"resourceStatus":{"allOf":[{"$ref":"#/components/schemas/common.ResourceStatusEnum"}],"description":"Current resource status","readOnly":true},"targetSpec":{"allOf":[{"$ref":"#/components/schemas/zimbra.PlatformPutTargetSpec"}],"description":"Object representing platform","readOnly":true}}}},"securitySchemes":{"oAuth2AuthCode":{"type":"oauth2","description":"Oauth2","x-client-id":"1bb9c7df371741c0","x-client-secret":"a5b4de870aca620d10fbf63cd18d205b","flows":{"authorizationCode":{"authorizationUrl":"https://auth.eu.ovhcloud.com/oauth2/authorize","tokenUrl":"https://auth.eu.ovhcloud.com/oauth2/token","scopes":{"account/all":"Manage your account","all":"Manage your whole account and all your services","services/all":"Manage your services lifecycle and billing"}}}}}},"paths":{"/zimbra/platform":{"get":{"operationId":"getAllZimbraPlatforms","summary":"List platforms","description":"Returns the platforms of the account with their current state. Filter them by `projectId`.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"header","name":"X-Pagination-Cursor","description":"Pagination cursor","schema":{"type":"string"}},{"in":"header","name":"X-Pagination-Size","description":"Pagination size","schema":{"type":"integer"}},{"in":"query","name":"iamTags","description":"Filter resources on IAM tags","schema":{"type":"object","additionalProperties":{"type":"array","items":{"$ref":"#/components/schemas/iam.resource.TagFilter"}}}},{"in":"query","name":"projectId","description":"Identifier of the project","schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/zimbra.PlatformResponseWithIAM"}}}}}},"x-developer-hub-navigation":[["Web Cloud","Email and Collaborative Solutions","Zimbra","Platforms@@@10"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/v2/zimbra/platform\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/v2/zimbra/platform\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"zimbra:apiovh:platform/get","required":true}],"x-expanded-response":"ZimbraPlatformResponseWithIAM"}},"/zimbra/platform/{platformId}":{"get":{"operationId":"getZimbraPlatform","summary":"Get a platform","description":"Returns the name and description of the platform, its number of organizations, its storage quota per account and its account statistics per offer.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"platformId","description":"Platform ID","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/zimbra.PlatformResponseWithIAM"}}}},"404":{"description":"Error 404 response","content":{"application/json":{"schema":{"type":"object","description":"Common error model","properties":{"class":{"type":"string","description":"Class of the error"},"message":{"type":"string","description":"Error message"}}},"examples":{"Client::NotFound::PlatformNotFound":{"value":{"class":"Client::NotFound::PlatformNotFound","message":"The platform was not found"}}}}}}},"x-developer-hub-navigation":[["Web Cloud","Email and Collaborative Solutions","Zimbra","Platforms@@@20"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/v2/zimbra/platform/{platformId}\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/v2/zimbra/platform/{platformId}\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"zimbra:apiovh:platform/get","required":true}]},"put":{"operationId":"editZimbraPlatform","summary":"Update a platform","description":"Updates the name or description of the platform. When set, `checksum` must match the current checksum of the platform, otherwise the update is rejected.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"platformId","description":"Platform ID","required":true,"schema":{"type":"string","format":"uuid"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/zimbra.PlatformPutPayload"}}}},"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/zimbra.PlatformResponse"}}}},"404":{"description":"Error 404 response","content":{"application/json":{"schema":{"type":"object","description":"Common error model","properties":{"class":{"type":"string","description":"Class of the error"},"message":{"type":"string","description":"Error message"}}},"examples":{"Client::NotFound::PlatformNotFound":{"value":{"class":"Client::NotFound::PlatformNotFound","message":"The platform was not found"}}}}}},"409":{"description":"Error 409 response","content":{"application/json":{"schema":{"type":"object","description":"Common error model","properties":{"class":{"type":"string","description":"Class of the error"},"message":{"type":"string","description":"Error message"}}},"examples":{"Client::Conflict::UndesiredObjectStatus":{"value":{"class":"Client::Conflict::UndesiredObjectStatus","message":"The object is in an undesired status"}}}}}},"412":{"description":"Error 412 response","content":{"application/json":{"schema":{"type":"object","description":"Common error model","properties":{"class":{"type":"string","description":"Class of the error"},"message":{"type":"string","description":"Error message"}}},"examples":{"Client::PreconditionFailed::InvalidChecksum":{"value":{"class":"Client::PreconditionFailed::InvalidChecksum","message":"The checksum is invalid because the object has expired"}}}}}}},"x-developer-hub-navigation":[["Web Cloud","Email and Collaborative Solutions","Zimbra","Platforms@@@30"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\n# Request body type: zimbra.PlatformPutPayload\nresult = client.put(\"/v2/zimbra/platform/{platformId}\",\n\tchecksum = None, # Known checksum of the resource, allowing to prevent unwanted side effects (type: string)\n\ttargetSpec = None, # Target platform specification (type: zimbra.PlatformPutTargetSpec)\n)\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n// Request body type: zimbra.PlatformPutPayload\n$result = $ovh->put(\"/v2/zimbra/platform/{platformId}\", array(\n\tchecksum => null, // Known checksum of the resource, allowing to prevent unwanted side effects (type: string)\n\ttargetSpec => null, // Target platform specification (type: zimbra.PlatformPutTargetSpec)\n));\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"zimbra:apiovh:platform/edit","required":true}]}},"/zimbra/platform/{platformId}/refreshQuotaUsage":{"post":{"operationId":"refreshZimbraPlatformQuotaUsage","summary":"Refresh quota usage","description":"Recomputes the quota usage (`quota.used` and `quotaRefreshedAt`) of every email account of the platform. The refresh runs asynchronously.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"platformId","description":"Platform ID","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"successful operation"}},"x-developer-hub-navigation":[["Web Cloud","Email and Collaborative Solutions","Zimbra","Platforms@@@40"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.post(\"/v2/zimbra/platform/{platformId}/refreshQuotaUsage\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->post(\"/v2/zimbra/platform/{platformId}/refreshQuotaUsage\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"zimbra:apiovh:platform/edit","required":true}]}}}}
